#include <fstream>
using namespace std;

// very simple function to read in an 8 bit bitmap and copy the
// pixels to an array of unsigned char. Note: demo code only,
// no checking whether the bitmap is actually 8bit
unsigned char *LoadBMPFile(const char *fileName, int *dx, int *dy)
{
  unsigned short header[27];  // header is 54 bytes, smallest member is WORD
  unsigned char *pix = 0;

  ifstream bmpFile(fileName,ios::binary);
  bmpFile.read((char *)header, 54);
  int bitsOffset = header[5];
  *dx = header[9];
  *dy = header[11];
  bmpFile.seekg(bitsOffset, ios_base::beg);
  int numPix = *dx * *dy;
  pix = new unsigned char [numPix];
  bmpFile.read((char *)pix, numPix);
  return pix;
}

void SaveBMPFile(const char *fileName, unsigned char *pix, int dx, int dy)
{
  ofstream bmpFile(fileName, ios::binary);
  bmpFile.write("B", 1);
  bmpFile.write("M", 1);
  int bitsOffset = 54 + 256*4; 
  int size = bitsOffset + dx*dy; //header plus 256 entry LUT plus pixels
  bmpFile.write((const char *)&size, 4);
  int reserved = 0;
  bmpFile.write((const char *)&reserved, 4);
  bmpFile.write((const char *)&bitsOffset, 4);
  int bmiSize = 40;
  bmpFile.write((const char *)&bmiSize, 4);
  bmpFile.write((const char *)&dx, 4);
  bmpFile.write((const char *)&dy, 4);
  short planes = 1;
  bmpFile.write((const char *)&planes, 2);
  short bitCount = 8;
  bmpFile.write((const char *)&bitCount, 2);
  int i, temp = 0;
  for (i=0; i<6; i++)
    bmpFile.write((const char *)&temp, 4);  // zero out optional color info
  // write a linear LUT
  char lutEntry[4]; // blue,green,red
  lutEntry[3] = 0;  // reserved part
  for (i=0; i<256; i++)
  {
    lutEntry[0] = lutEntry[1] = lutEntry[2] = i;
    bmpFile.write(lutEntry, sizeof lutEntry);
  }
  // write the actual pixels
  bmpFile.write((const char *)pix, dx*dy);
}
