/********************************************************************
 * Code accompanying "The Embedded Angle" column in CUJ
 * Copyright 2002-2003 by Miro Samek, http://www.quantum-leaps.com 
 * All Rights Reserved.
 *******************************************************************/
#include "fsm.h"

static Event const entryEvt = { ENTRY_SIG }; 
static Event const exitEvt = { EXIT_SIG }; 

void FsmInitialTran_(Fsm *me, State target) {
   me->state__ = target;                  /* change current state */
   FsmDispatch(me, &entryEvt);                /* enter the target */
}

void FsmTran_(Fsm *me, State target) {
   FsmDispatch(me, &exitEvt);                  /* exit the source */
   me->state__ = target;                  /* change current state */
   FsmDispatch(me, &entryEvt);                /* enter the target */
}


