/////////////////////////////////////////////////////////////////////
// Code accompanying "The Embedded Angle" column in CUJ
// Copyright 2002-2003 by Miro Samek, http://www.quantum-leaps.com 
// All Rights Reserved.
/////////////////////////////////////////////////////////////////////
#ifndef fsm_h
#define fsm_h

typedef short Signal;
struct Event {
   Signal sig;
};

enum {                                        /* reserved signals */
   ENTRY_SIG, 
   EXIT_SIG,
   USER_SIG
};

class Fsm {
public:
   typedef void (Fsm::*State)(Event const *);

   Fsm(State initial) { myState = initial; }
   virtual ~Fsm() {}  // virtual Xtor
   void init(Event const *e = 0) { (this->*myState)(e); }
   void dispatch(Event const *e) { (this->*myState)(e); }
   void initialTran(State target);
   void tran(State target);
private:
   State myState;
};

#endif // fsm_h
