//-----------------------------------------------------------------------------
// File: checksum.hh 
// Date Created:
// Author: Martin Casado, Norman Franke
//
// Description:
//
// Entry hook to determine which checksum routine to use for a given packet
//
//
// ----------------------------------------------------------------------------
//
//    Copyright 2003. The Regents of the University of California.
//    All rights reserved.
//
//    This work was produced at the University of California, Lawrence Livermore
//    National Laboratory (UC LLNL) under contract no. W-7405-ENG-48 (Contract
//    48) between the U.S. Department of Energy (DOE) and The Regents of the
//    University of California (University) for the operation of UC LLNL.
//    Copyright is reserved to the University for purposes of controlled
//    dissemination, commercialization through formal licensing, or other
//    disposition under terms of Contract 48; DOE policies, regulations and
//    orders; and U.S. statutes. The rights of the Federal Government are
//    reserved under Contract 48 subject to the restrictions agreed upon by the
//    DOE and University as allowed under DOE Acquisition Letter 91-7.
//
//    DISCLAIMER
//    This software was prepared as an account of work sponsored by an
//    agency of the United States Government. Neither the United States
//    Government nor the University of California nor any of their employees,
//    makes any warranty, express or implied, or assumes any liability or
//    responsibility for the accuracy, completeness, or usefulness of any
//    information, apparatus, product, or process disclosed, or represents that
//    its use would not infringe protectedly-owned rights. Reference herein to any
//    specific commercial products, process, or service by trade name, trademark,
//    manufacturer, or otherwise, does not necessarily constitute or imply its
//    endorsement, recommendation, or favoring by the United States Government or
//    the University of California. The views and opinions of authors expressed
//    herein do not necessarily represent those of the United States
//    Government or the University of California, and shall not be used for
//    advertising or product endorsement purposes.
//
//-----------------------------------------------------------------------------

#ifndef CHECKSUM_HH
#define CHECKSUM_HH

namespace pacman
{

//-----------------------------------------------------------------------------
template <class T>
struct no_checksum_known_for_this_type
{
    static void func(T&  in)
    { ; }
};
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
template <class T>
struct which_csum
{
    typedef no_checksum_known_for_this_type<T> Type;
};
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
template <typename T>
void checksum(T& in)
{ 
    which_csum<T>::Type::func(in); 
}
//-----------------------------------------------------------------------------

} // -- namespace pacman

#endif  // -- CHECKSUM_HH
