#include <OB\CORBA.h>
#include "test.h"
#include "test_impl.h"
#include <iostream>
#include <fstream>

using namespace std;

int onewaycounter;
int twowaycounter;

int run(CORBA::ORB_ptr orb)
{
     CORBA::Object_var poaObj = orb->resolve_initial_references("RootPOA");
     PortableServer::POA_var rootPoa = PortableServer::POA::_narrow(poaObj);

     PortableServer::POAManager_var manager = rootPoa->the_POAManager();

     cout << "creating the servant" << endl;
     test_impl *impl = new test_impl();
     PortableServer::ServantBase_var servant = impl;

     test_var t = impl->_this();

     {
          CORBA::String_var s = orb->object_to_string(t);
          ofstream reffile("ref.txt");
          reffile << s;
     }

     manager->activate();
     orb->run();

     return EXIT_SUCCESS;
}

int main(int argc, char *argv[])
{
     cout << "starting server" << endl;

     int status = EXIT_SUCCESS;
     CORBA::ORB_var orb;

     try
     {
          cout << "initializing ORB" << endl;
          orb = CORBA::ORB_init(argc, argv);
          status = run(orb);
     }
     catch (const CORBA::Exception &)
     {
          cout << "exception caught" << endl;
          status = EXIT_FAILURE;
     }

     if (!CORBA::is_nil(orb))
     {
          try
          {
               cout << "destroying ORB" << endl;
               orb->destroy();
          }
          catch (const CORBA::Exception &)
          {
               cout << "exception caught" << endl;
               status = EXIT_FAILURE;
          }
     }

     return status;
}
