echo ''
echo 'This is a configuration script for the YAMI library.'
echo ''
echo 'I will ask you a couple of questions considering your'
echo 'environment and preferences.'
echo 'Please enter digits and small characters only.'
echo ''

echo 'What operating system are you running on?'
echo '(If your system is not in the list, try to pick the closest one)'
echo '1) FreeBSD'
echo '2) Linux'
echo '3) SunOS'

ok=no
while [ $ok != yes ]
do
    read os
    case $os in
        1|2|3)
            ok=yes
            ;;
        *)
            echo 'wrong answer'
            ;;
    esac
done

echo ''
echo 'Do you want to use YAMI from C or C++ language?'
echo '(It is also required if you want to use standard services.)'
echo 'y) Yes'
echo 'n) No'

ok=no
while [ $ok != yes ]
do
    read use_core
    case $use_core in
        y|n)
            ok=yes
            ;;
        *)
            echo 'wrong answer'
            ;;
    esac
done

if [ $use_core = y ]
then
    echo ''
    echo 'Do you want to compile the library with threading support?'
    echo '(If you select No, the library functionality will be very limited,'
    echo 'threading is also required for standard services.)'
    echo 'y) Yes'
    echo 'n) No'

    ok=no
    while [ $ok != yes ]
    do
        read use_threads
        case $use_threads in
            y|n)
                ok=yes
                ;;
            *)
                echo 'wrong answer'
                ;;
        esac
    done

    echo ''
    echo 'Do you want to compile examples for C language?'
    echo 'y) Yes'
    echo 'n) No'

    ok=no
    while [ $ok != yes ]
    do
        read c_tuts
        case $c_tuts in
            y|n)
                ok=yes
                ;;
            *)
                echo 'wrong answer'
                ;;
        esac
    done

    echo ''
    echo 'Do you want to compile examples for C++ language?'
    echo 'y) Yes'
    echo 'n) No'

    ok=no
    while [ $ok != yes ]
    do
        read cpp_tuts
        case $cpp_tuts in
            y|n)
                ok=yes
                ;;
            *)
                echo 'wrong answer'
                ;;
        esac
    done

    echo ''
    echo 'Do you want to use the YDL compiler?'
    echo 'y) Yes'
    echo 'n) No'

    ok=no
    while [ $ok != yes ]
    do
        read use_ydl
        case $use_ydl in
            y|n)
                ok=yes
                ;;
            *)
                echo 'wrong answer'
                ;;
        esac
    done

    if [ $use_ydl = y ]
    then
        echo ''
        echo 'Do you want to compile the YDL examples?'
        echo 'y) Yes'
        echo 'n) No'

        ok=no
        while [ $ok != yes ]
        do
        read ydl_tuts
        case $ydl_tuts in
            y|n)
                ok=yes
                ;;
            *)
                echo 'wrong answer'
                ;;
            esac
        done
    fi
fi

echo ''
echo 'Do you want to use YAMI from Python?'
echo 'y) Yes'
echo 'n) No'

ok=no
while [ $ok != yes ]
do
    read use_python
    case $use_python in
        y|n)
            ok=yes
            ;;
        *)
            echo 'wrong answer'
            ;;
    esac
done

if [ $use_python = y ]
then
    echo 'Please enter the path for your Python include directory'
    echo '(this directory should contain the Python.h file)'
    echo 'or just press enter for the default: /usr/local/include/python2.2'
    read python_include
    if [ -z $python_include ]
    then
        python_include=/usr/local/include/python2.2
    fi
fi

echo ''
echo 'Do you want to use YAMI from Tcl?'
echo 'y) Yes'
echo 'n) No'

ok=no
while [ $ok != yes ]
do
    read use_tcl
    case $use_tcl in
        y|n)
            ok=yes
            ;;
        *)
            echo 'wrong answer'
            ;;
    esac
done

if [ $use_tcl = y ]
then
    echo 'Please enter the path for your Tcl include directory'
    echo '(this directory should contain the tcl.h file)'
    echo 'or just press enter for the default: /usr/local/include/tcl8.3'
    read tcl_include
    if [ -z $tcl_include ]
    then
        tcl_include=/usr/local/include/tcl8.3
    fi

    if [ $os = 1 ]
    then
        echo 'Note: On FreeBSD, the default Tcl package does not support threads.'
        echo '      You need to recompile the package with threads in order to use YAMI.'
    fi
fi

if [ $use_threads = y ]
then
    echo ''
    echo 'Do you want to use standard services: Property and Events?'
    echo 'y) Yes'
    echo 'n) No'

    ok=no
    while [ $ok != yes ]
    do
        read use_services
        case $use_services in
            y|n)
                ok=yes
                ;;
            *)
                echo 'wrong answer'
                ;;
        esac
    done
fi

echo ''
echo 'OK, now I will write all the options to the src/config.mk file.'
echo 'Enter y to continue or any other key to abort.'
echo 'y) write file src/config.mk'
echo 'n) abort'

ok=no
while [ $ok != yes ]
do
    read commit
    case $commit in
        y|n)
            ok=yes
            ;;
        *)
            echo 'wrong answer'
            ;;
    esac
done

if [ $commit != y ]
then
    exit
fi

conf=src/config.mk

echo '# this is configuration file for the YAMI library' > $conf
echo '' >> $conf
echo '# you may wish to change some options for your particular environment' >> $conf
echo '' >> $conf
echo '# system-specific settings:' >> $conf
echo '# CCOMP        - name of the C compiler' >> $conf
echo '# CORE_FLAGS   - compiler options for compiling the core library' >> $conf
echo '# APP_FLAGS    - compiler options for user applications and examples' >> $conf
echo '# SHARED_FLAGS - options for loadable module (for Python and Tcl)' >> $conf
echo '# SYS_LIBS     - common system libraries for threads, networking, etc.' >> $conf
echo '# CPP          - name of the C++ compiler' >> $conf
echo '# CPP_FLAGS    - additional options used for C++ code' >> $conf
echo '' >> $conf

case $os in
    1)
        # FreeBSD

        echo 'CCOMP = gcc' >> $conf
        if [ $use_threads = y ]
        then
            echo 'CORE_FLAGS = -O2 -D_THREAD_SAFE' >> $conf
            echo 'APP_FLAGS = -O2 -D_THREAD_SAFE' >> $conf
        else
            echo 'CORE_FLAGS = -O2 -DYAMI_NO_THREADS' >> $conf
            echo 'APP_FLAGS = -O2' >> $conf
        fi
        echo 'SHARED_FLAGS = -O2 -fpic -D_THREAD_SAFE' >> $conf
        if [ $use_threads = y ]
        then
            echo 'SYS_LIBS = -pthread -lc_r' >> $conf
        else
            echo 'SYS_LIBS =' >> $conf
        fi
        echo 'CPP = g++' >> $conf
        echo 'CPP_FLAGS = -DYAMI_NO_WSTRING' >> $conf
        ;;
    2)
        # Linux

        echo 'CCOMP = gcc' >> $conf
        if [ $use_threads = y ]
        then
            echo 'CORE_FLAGS = -O2' >> $conf
        else
            echo 'CORE_FLAGS = -O2 -DYAMI_NO_THREADS' >> $conf
        fi
        echo 'APP_FLAGS = -O2' >> $conf
        echo 'SHARED_FLAGS = -O2 -fpic' >> $conf
        if [ $use_threads = y ]
        then
            echo 'SYS_LIBS = -lpthread' >> $conf
        else
            echo 'SYS_LIBS =' >> $conf
        fi
        echo 'CPP = g++' >> $conf
        echo 'CPP_FLAGS = -DYAMI_NO_WSTRING' >> $conf
        ;;
    3)
        # SunOS

        echo 'CCOMP = cc' >> $conf
        if [ $use_threads = y ]
        then
            echo 'CORE_FLAGS = -O -mt' >> $conf
            echo 'APP_FLAGS = -O -mt' >> $conf
        else
            echo 'CORE_FLAGS = -O -DYAMI_NO_THREADS' >> $conf
            echo 'APP_FLAGS = -O' >> $conf
        fi
        echo 'SHARED_FLAGS = -O -mt -G -pic' >> $conf
        if [ $use_threads = y ]
        then
            echo 'SYS_LIBS = -lpthread -lsocket -lnsl' >> $conf
        else
            echo 'SYS_LIBS = -lsocket -lnsl' >> $conf
        fi
        echo 'CPP = CC' >> $conf
        echo 'CPP_FLAGS =' >> $conf
esac

echo '' >> $conf
echo '# include paths needed for scripting support' >> $conf

echo '' >> $conf
if [ $use_python = y ]
then
    echo '# include path to Python library:' >> $conf
    echo 'PYTHON_INCLUDE =' $python_include >> $conf
else
    echo '# (Python not selected)' >> $conf
fi

echo '' >> $conf
if [ $use_tcl = y ]
then
    echo '# include path to Tcl library:' >> $conf
    echo 'TCL_INCLUDE =' $tcl_include >> $conf
else
    echo '# (Tcl not selected)' >> $conf
fi

echo '' >> $conf
echo '# finally, the targets that you want to compile:' >> $conf
echo '# core     - the YAMI Core Library' >> $conf
echo '# coretuts - the tutorial examples for core library' >> $conf
echo '# cpptuts  - the tutorial examples for C++ wrappers' >> $conf
echo '# ydl      - the YAMI Definition Language Compiler' >> $conf
echo '# python   - the YAMI Python Module' >> $conf
echo '# tcl      - the YAMI Tcl Module' >> $conf
echo '# services - standard services (Property and Events)' >> $conf
echo '' >> $conf
printf 'I_WANT_TO_COMPILE = ' >> $conf

if [ $use_core = y ]
then
    printf 'core ' >> $conf
fi
if [ $c_tuts = y ]
then
    printf 'coretuts ' >> $conf
fi
if [ $cpp_tuts = y ]
then
    printf 'cpptuts ' >> $conf
fi
if [ $use_ydl = y ]
then
    printf 'ydl ' >> $conf
fi
if [ $use_python = y ]
then
    printf 'python ' >> $conf
fi
if [ $use_tcl = y ]
then
    printf 'tcl ' >> $conf
fi
if [ $use_services = y ]
then
    printf 'services ' >> $conf
fi

echo '' >> $conf
echo '' >> $conf
echo '# Have a nice build!' >> $conf

echo ''
echo 'File src/config.mk has been saved.'
echo 'You may wish to check it and improve it further.'
echo ''
echo 'In order to compiler all chosen components, just run make.'
echo ''
