#include "yamic.h"
#include "yamiparams.h"
#include <stdio.h>

const char *serverhost  = "127.0.0.1";
const int  serverport   = 12340;
const int  clientport   = 12341;
const char *domainname  = "someDomain";
const char *objectname  = "calculator";

int main()
{
     HYAMIAGENT agent;
     HPARAMSET paramset, returnparamset;
     HMESSAGE hm;
     enum msgStatus status;
     int result;
     
     yamiNetInitialize();
     
     yamiCreateAgent(&agent, clientport, NULL);

     yamiAgentDomainRegister(agent, domainname,
          serverhost, serverport, 2);

     yamiCreateParamSet(&paramset, 2);

     yamiSetInt(paramset, 0, 100);
     yamiSetInt(paramset, 1, 20);

     yamiAgentMsgSend(agent, domainname,
          objectname, "add", paramset, &hm);

     yamiDestroyParamSet(paramset);

     yamiAgentMsgWait(hm);

     yamiAgentMsgGetStatus(hm, &status);

     if (status == eReplied)
     {
          yamiAgentMsgGetResponse(hm, &returnparamset);

          yamiGetInt(returnparamset, 0, &result);

          yamiDestroyParamSet(returnparamset);

          printf("the result is %d\n", result);
     }
     else if (status == eRejected)
     {
          puts("the last message was rejected");
     }
     else
     {
          puts("no correct reply");
     }

     yamiAgentMsgDestroy(hm);
     yamiDestroyAgent(agent);
     yamiNetCleanup();

     return 0;
}
