#include "yamic.h"
#include "yamiparams.h"
#include <stdio.h>
#include <string.h>

#define MAXBUF 1000

void readline(char *buf)
{
     int i;
     
     fgets(buf, MAXBUF, stdin);
     for (i = strlen(buf); i >= 0; --i)
          if (buf[i] == '\n' || buf[i] == '\r')
               buf[i] = 0;
}

int main()
{
     HYAMIAGENT agent;
     HPARAMSET params;
     char buf[MAXBUF];
     
     yamiNetInitialize();
     
     yamiCreateAgent(&agent, 12341, NULL);
     yamiAgentDomainRegister(agent,
          "echoserver", "127.0.0.1", 12340, 2);
     
     readline(buf);
     while (!feof(stdin))
     {
          yamiCreateParamSet(&params, 1);
          yamiSetString(params, 0, buf);
          
          yamiAgentMsgSend(agent, "echoserver",
               "echo", "print", params, NULL);
          
          yamiDestroyParamSet(params);

          readline(buf);
     }
     
     yamiDestroyAgent(agent);     
     yamiNetCleanup();
     
     return 0;
}
