#include "yamic.h"
#include "yamiparams.h"
#include "yamierrors.h"
#include <stdio.h>
#include <string.h>

#define MAXBUF 1000

void readline(char *buf)
{
     int i;
     
     fgets(buf, MAXBUF, stdin);
     for (i = strlen(buf); i >= 0; --i)
          if (buf[i] == '\n' || buf[i] == '\r')
               buf[i] = 0;
}

int main()
{
     struct yamipolicies policies;
     HYAMIAGENT agent;
     HPARAMSET params;
     char buf[MAXBUF];
     int cc;
     
     cc = yamiNetInitialize();
     if (cc != YAMIOK)
     {
          puts("cannot initialize network");
          return -1;
     }
     
     yamiGetDefaultPolicies(&policies);
     policies.hassender = 0;
     
     cc = yamiCreateAgent(&agent, 12341, &policies);
     if (cc != YAMIOK)
     {
          puts("cannot create agent");
          return -1;
     }
     
     cc = yamiAgentDomainRegister(agent,
          "echoserver", "127.0.0.1", 12340, 2);
     if (cc != YAMIOK)
     {
          puts("cannot register domain");
          return -1;
     }
     
     readline(buf);
     while (!feof(stdin))
     {
          cc = yamiCreateParamSet(&params, 1);
          if (cc != YAMIOK)
          {
               puts("cannot create paramset");
               return -1;
          }
          
          cc = yamiSetString(params, 0, buf);
          if (cc != YAMIOK)
          {
               puts("cannot set string value");
               return -1;
          }
          
          cc = yamiAgentMsgSend(agent, "echoserver",
               "echo", "print", params, NULL);
          if (cc != YAMIOK)
          {
               puts("cannot send message");
               return -1;
          }
          
          cc = yamiDestroyParamSet(params);
          if (cc != YAMIOK)
          {
               puts("cannot destroy paramset");
               return -1;
          }

          readline(buf);
     }
     
     cc = yamiDestroyAgent(agent);
     if (cc != YAMIOK)
     {
          puts("cannot destroy agent");
          return -1;
     }
     
     cc = yamiNetCleanup();
     if (cc != YAMIOK)
     {
          puts("cannot cleanup network");
          return -1;
     }
     
     return 0;
}
