#include "yamic.h"
#include "yamiparams.h"
#include <stdio.h>
#include <string.h>

int main()
{
     HYAMIAGENT agent;
     HINCMSG incoming;
     HPARAMSET params;
     const char *msgname;
     const char *line;
     
     yamiNetInitialize();
     
     yamiCreateAgent(&agent, 12340, NULL);
     yamiAgentObjectRegister(agent, "echo",
          polling, NULL, NULL);
     
     puts("server started");
     while (1)
     {
          yamiAgentIncomingMsgGetNext(agent, "echo",
               &incoming, 1);
          
          yamiAgentIncomingMsgGetMsgName(incoming,
               &msgname);
          
          if (strcmp(msgname, "shutdown") == 0)
          {
               puts("received the shutdown message");
               yamiAgentDestroyIncomingMsg(incoming);
               break;
          }
          else /* if (strcmp(msgname, "print") == 0) */
          {
               yamiAgentIncomingMsgGetParameters(incoming,
                    &params);
               
               yamiGetStringBuffer(params, 0, &line);
               puts(line);
               
               yamiDestroyParamSet(params);
               yamiAgentDestroyIncomingMsg(incoming);
          }
     }
     
     yamiDestroyAgent(agent);
     yamiNetCleanup();
     
     return 0;
}
