#include "yamic.h"
#include "yamiparams.h"
#include "yamisynchro.h"
#include <stdio.h>
#include <string.h>

HSEMAPHORE sem;

void servant(HINCMSG incoming)
{
     HPARAMSET params;
     const char *msgname;
     const char *line;
     
     yamiAgentIncomingMsgGetMsgName(incoming, &msgname);
     if (strcmp(msgname, "shutdown") == 0)
     {
          puts("received the shutdown message");
          yamiSemaphoreRelease(sem);
     }
     else /* if (strcmp(msgname, "print") == 0) */
     {
          yamiAgentIncomingMsgGetParameters(incoming,
               &params);
          
          yamiGetStringBuffer(params, 0, &line);
          puts(line);
               
          yamiDestroyParamSet(params);
     }
     
     yamiAgentIncomingMsgEat(incoming);
}

int main()
{
     HYAMIAGENT agent;

     yamiNetInitialize();

     yamiCreateSemaphore(&sem, 0);
          
     yamiCreateAgent(&agent, 12340, NULL);
     yamiAgentObjectRegister(agent, "echo",
          passive_singlethreaded, servant, NULL);

     puts("server started");
          
     yamiSemaphoreAcquire(sem);
     
     /* the process reaches this code       */
     /* only when the semaphore is released */
          
     yamiDestroyAgent(agent);
     yamiDestroySemaphore(sem);
     yamiNetCleanup();
     
     return 0;
}
