#include "yami++.h"
#include <iostream>

using namespace YAMI;
using namespace std;

const char *serverhost  = "127.0.0.1";
const int  serverport   = 12340;
const int  clientport   = 12341;
const char *domainname  = "someDomain";
const char *objectname  = "calculator";

int main()
{
     netInitialize();
     {
          Agent agent(clientport);
          agent.domainRegister(domainname,
               serverhost, serverport, 2);

          ParamSet paramset(2);

          paramset.setInt(0, 100);
          paramset.setInt(1, 20);

          auto_ptr<Message> msg(agent.send(domainname,
               objectname, "add", paramset));

          msg->wait();

          Message::eStatus status = msg->getStatus();

          if (status == Message::eReplied)
          {
               auto_ptr<ParamSet> retpar(msg->getResponse());

               int result = retpar->getInt(0);

               cout << "the result is " << result << endl;
          }
          else if (status == Message::eRejected)
          {
               cout << "the last message was rejected"
                    << endl;
          }
          else
          {
               cout << "no correct reply" << endl;
          }
     }
     netCleanup();

     return 0;
}
