#include "yami++.h"
#include <iostream>
#include <string>

using namespace YAMI;
using namespace std;

// for sscanf
#include <stdio.h>

const char *serverhost  = "127.0.0.1";
const int  serverport   = 12340;
const int  clientport   = 12341;
const char *domainname  = "someDomain";
const char *objectname  = "calculator";

int main()
{
     cout << "starting the client" << endl;

     netInitialize();
     {
          Agent agent(clientport);
          agent.domainRegister(domainname,
               serverhost, serverport, 2);

          while (1)
          {
               cout << "please enter the expression (or \'quit\'): ";

               string str;
               getline(cin, str);

               if (str == "quit")
                    break;

               // note: I use sscanf here, because
               // istringstream is not everywhere available

               int val1, val2;
               char op;

               if (sscanf(str.c_str(), "%d%c%d", &val1, &op, &val2) != 3)
               {
                    cout << "wrong expression" << endl;
                    continue;
               }

               string msgname;
               if (op == '+')
                    msgname = "add";
               else if (op == '-')
                    msgname = "sub";
               else if (op == '*')
                    msgname = "mul";
               else if (op == '/')
                    msgname = "div";
               else
               {
                    cout << "wrong expression" << endl;
                    continue;
               }

               ParamSet paramset(2);
               paramset.setInt(0, val1);
               paramset.setInt(1, val2);

               auto_ptr<Message> msg(agent.send(domainname, objectname,
                    msgname.c_str(), paramset));


               /* set the 10 seconds timeout */
               msg->setTimeOut(10);

               msg->wait();

               Message::eStatus status =msg->getStatus();

               if (status == Message::eReplied)
               {
                    auto_ptr<ParamSet> retpar(msg->getResponse());

                    int result = retpar->getInt(0);

                    cout << str << " = " << result << endl;
               }
               else if (status == Message::eRejected)
               {
                    cout << "the last message was rejected" << endl;
               }
               else if (status == Message::eTimedOut)
               {
                    cout << "the message was timed out" << endl;
                    break;
               }
               else
               {
                    cout << "the last message was not replied correctly"
                         << endl;
                    break;
               }
          }
     }

     cout << "thank you!" << endl;

     netCleanup();

     return 0;
}
