#include "yami++.h"
#include <iostream>
#include <string>

using namespace YAMI;
using namespace std;

class Server : public PassiveObject
{
public:
     Server(Semaphore &s) : sem_(s) {}

     void call(IncomingMsg &incoming)
     {
          string msgname(incoming.getMsgName());
          if (msgname == "shutdown")
          {
               cout << "received the shutdown message"
                    << endl;
               sem_.release();
          }
          else // if (msgname == "print")
          {
               auto_ptr<ParamSet> params
                    (incoming.getParameters());

               string line;
               params->getString(0, line);
               cout << line << endl;
          }

          incoming.eat();
     }

private:
     Semaphore &sem_;
};

int main()
{
     netInitialize();
     {
          Semaphore sem(0);
          Server servant(sem);

          Agent agent(12340);
          agent.objectRegister("echo",
               Agent::ePassiveSingleThreaded,
               &servant);

          cout << "server started" << endl;

          sem.acquire();

          // the process quits this block
          // only when the semaphore is released
     }
     netCleanup();
     
     return 0;
}
