package require YAMI

set serverport 12340
set objectname "calculator"

puts "starting the server"

set agent [YAMI::Agent $serverport]
$agent objectRegister $objectname

puts "waiting for messages..."

while {1} {
    set incoming [$agent getIncoming $objectname 1]
    set msgname [$incoming getMsgName]

    puts "I have received the message: $msgname"
    
    if {$msgname != "add" && $msgname != "sub" && \
        $msgname != "mul" && $msgname != "div"} {
        puts "unknown name - rejecting"
        $incoming reject
	   $incoming -delete
        continue
    }
    
    set params [$incoming getParameters]
    set val1 [lindex $params 0]
    set val2 [lindex $params 1]
    
    if {$msgname == "add"} {
        set result [expr $val1 + $val2]
    } elseif {$msgname == "sub"} {
        set result [expr $val1 - $val2]
    } elseif {$msgname == "mul"} {
        set result [expr $val1 * $val2]
    } else {

        if {$val2 == 0} {
            puts "dividing by 0 not allowed"
            puts "rejecting"
            $incoming reject
            $incoming -delete
            continue
        } else {
            set result [expr $val1 / $val2]
        }
    }

    $incoming reply [list [list $result i]]
    $incoming -delete
}

$agent -delete
