#include "yami++.h"
#include "calc_client.h"
#include <iostream>
#include <string>

// for sscanf
#include <stdio.h>

using namespace std;
using namespace YAMI;

const char *serverhost  = "127.0.0.1";
const int  serverport   = 12340;
const int  clientport   = 12341;
const char *domainname  = "someDomain";
const char *objectname  = "calculator";

int main()
{
    try
    {
        netInitialize();
        {
        Agent agent(clientport);
        agent.domainRegister(domainname,
            serverhost, serverport, 2);

        calculator calc(agent, domainname, objectname);

        while (1)
        {
            cout << "please enter the expression"
               " (or \'quit\'): ";

            string str;
            getline(cin, str);

            if (str == "quit")
                 break;

            // note: I use sscanf here, because
            // istringstream is not everywhere available

            int val1, val2;
            char op;

            if (sscanf(str.c_str(), "%d%c%d",
                &val1, &op, &val2) != 3)
            {
                cout << "wrong expression" << endl;
                continue;
            }

            try
            {
                int result;

                if (op == '+')
                    calc.add(val1, val2, result);
                else if (op == '-')
                    calc.sub(val1, val2, result);
                else if (op == '*')
                    calc.mul(val1, val2, result);
                else if (op == '/')
                    calc.div(val1, val2, result);
                else
                {
                    cout << "wrong expression" << endl;
                    continue;
                }

                cout << "the result is " << result << endl;
            }
            catch (const exception &e)
            {
                cout << "exception: "
                    << e.what() << endl;
            }
        }
        netCleanup();
        }
    }
    catch (const exception &e)
    {
        cout << "exception: " << e.what() << endl;
    }
    
    return 0;
}
