#include "yami++.h"
#include "calc_server.h"
#include <iostream>

using namespace std;
using namespace YAMI;

const int  serverport  = 12340;
const char *objectname = "calculator";

class calculator_Impl : public calculator_Skel
{
private:
    void add(int a, int b, int &c)
    {
        cout << "add " << a << " + " << b << endl;
        c = a + b;
    }

    void sub(int a, int b, int &c)
    {
        cout << "sub " << a << " - " << b << endl;
        c = a - b;
    }

    void mul(int a, int b, int &c)
    {
        cout << "mul " << a << " * " << b << endl;
        c = a * b;
    }

    void div(int a, int b, int &c)
    {
        cout << "div " << a << " / " << b << endl;
        if (b == 0)
        {
            cout << "dividing by 0 not allowed" << endl;
            throw 0;
        }

        c = a / b;
    }
};

int main()
{
    try
    {
        netInitialize();
        {
        Agent agent(serverport);
        calculator_Impl servant;

        agent.objectRegister(objectname,
            Agent::ePassiveSingleThreaded,
            &servant);

        cout << "waiting forever..." << endl;

        sleep(0);
        }
        netCleanup();
    }
    catch (const exception &e)
    {
        cout << "exception: " << e.what() << endl;
    }
    
    return 0;
}
