/*
 * yamilimits.h
 *
 * this file contains the general yami limitations
 *
 * Copyright (C) 2001-2002 Maciej Sobczak,
 * student at the Institute of Computer Science,
 * Warsaw University of Technology
 *
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 *
 */

#ifndef YAMILIMITS_INCLUDED
#define YAMILIMITS_INCLUDED

/* these constants are defined in the YAMI specification */

/* max length of the parameter-set size   */
#define MAXPARAMSETSIZE 1048576

/* max length of the parameter's raw data */
#define MAXPARAMSIZE      65536

/* max number of parameters in a set */
#define MAXPARAMS         65536

/* max length of the name */
#define MAXNAMELEN          256

/* these are default values used for Agent policies */

#define YAMIDEFAULT_AGENTLEVEL           2
#define YAMIDEFAULT_OBJQMAXLENGTH       10
#define YAMIDEFAULT_OBJQMAXSIZE    1048576
#define YAMIDEFAULT_DISPATCHERS          1
#define YAMIDEFAULT_HASSENDER            1
#define YAMIDEFAULT_SQMAXLENGTH        256
#define YAMIDEFAULT_SQMAXSIZE      1048576
#define YAMIDEFAULT_CONNPOOLSIZE        10
#define YAMIDEFAULT_SENDTRIES            5
#define YAMIDEFAULT_HASSOCKET            1
#define YAMIDEFAULT_REUSEADDR            0
#define YAMIDEFAULT_HASRECEIVER          1
#define YAMIDEFAULT_HASWAKER             1
#define YAMIDEFAULT_MTUSER               1

#endif
