# this is configuration file for the YAMI library

# you may wish to change some options for your particular environment

# system-specific settings:
# CCOMP        - name of the C compiler
# CORE_FLAGS   - compiler options for compiling the core library
# APP_FLAGS    - compiler options for user applications and examples
# SHARED_FLAGS - options for loadable module (for Python and Tcl)
# SYS_LIBS     - common system libraries for threads, networking, etc.
# CPP          - name of the C++ compiler
# CPP_FLAGS    - additional options used for C++ code

CCOMP = gcc
CORE_FLAGS = -O2 -D_THREAD_SAFE
APP_FLAGS = -O2 -D_THREAD_SAFE
SHARED_FLAGS = -O2 -fpic -D_THREAD_SAFE
SYS_LIBS = -pthread -lc_r
CPP = g++
CPP_FLAGS = -DYAMI_NO_WSTRING

# include paths needed for scripting support

# include path to Python library:
PYTHON_INCLUDE = /usr/local/include/python2.2

# include path to Tcl library:
TCL_INCLUDE = /usr/local/include/tcl8.3

# finally, the targets that you want to compile:
# core     - the YAMI Core Library
# coretuts - the tutorial examples for core library
# cpptuts  - the tutorial examples for C++ wrappers
# ydl      - the YAMI Definition Language Compiler
# python   - the YAMI Python Module
# tcl      - the YAMI Tcl Module
# services - standard services (Property and Events)

I_WANT_TO_COMPILE = core coretuts cpptuts ydl python tcl services 

# Have a nice build!
